SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
-- GetProcesses 'inconcert', 'name', '', NULL, NULL, 'SPEECH'
CREATE PROCEDURE [dbo].[GetProcesses]
(
	@VCC						VARCHAR(50) = NULL,
	@SearchCriteria				VARCHAR(50) = NULL,
	@SearchExpression			VARCHAR(50) = NULL,
	@StartDate					DATETIME,
	@EndDate					DATETIME,
	@Type						VARCHAR(50)
)
AS
BEGIN
	DECLARE @SQL NVARCHAR(MAX)
	IF @Type = 'ALL'
	BEGIN 
		SELECT [name],[name] as 'description'
			FROM dbo.[Process]
			WHERE [Status] = 'COMPLETE'
				AND [Type] = 'SPEECH'
				AND [VCC] = @VCC
		UNION ALL
		--UNIMOS A LOS PROCESOS DE QUALITY
		SELECT QPEP.[processId], EP.[Id]
		FROM dbo.[EvaluationPlan] (NOLOCK) EP 
			INNER JOIN (
			  SELECT [processId], MAX([CreatedDate]) AS CreatedDate
				FROM dbo.[EvaluationPlan] (NOLOCK)
				WHERE [Instance] =  @VCC
					AND [ProcessId] IS NOT NULL
					AND [Status] = 7
				GROUP BY [ProcessId]
			  ) AS QPEP
			ON EP.[CreatedDate] = QPEP.[CreatedDate]
				AND EP.[Instance] =  @VCC
				AND EP.[ProcessId] IS NOT NULL
				AND EP.[Status] =7


	END
	ELSE
	BEGIN
		SET @SQL = '
		SET NOCOUNT ON

		SELECT [VCC]																				''vcc'',
				[Name]																				''name'',
				[Description]																		''description'',
				[ClientId]																			''clientId'',
				[Percentage]																		''percentage'',
				[StatusDescription]																	''statusDescription'',
				(CASE WHEN [Status] IS NULL THEN ''UNKNOWN'' ELSE [Status] END)						''status'',
				[StartDate]																			''startDate'',
				[EndDate]																			''endDate'',
				[MinDurationTime]																	''minDurationTime'',
				[MaxDurationTime]																	''maxDurationTime'',
				[Language]																			''language'',
				[Environment]																		''environment'',
				[BatchScheduleId]																	''batchScheduleId'',
				[CreatedDate]																		''createdDate'',
				[CreatedByUserId]																	''createdByUserId'',
				[LastModifiedDate]																	''lastModifiedDate'',
				[LastModifiedByUserId]																''lastModifiedByUserId''
			FROM [Process] (NOLOCK)
			WHERE [VCC] = ''' + @VCC + '''
				AND ISNULL([Name], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''name'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
				AND ISNULL([Description], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''description'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
				AND ISNULL([ClientId], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''clientId'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
				AND ISNULL([Status], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''status'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
				AND ISNULL([Environment], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''environment'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END'

		IF(@StartDate IS NOT NULL AND @EndDate IS NOT NULL)
		BEGIN
			SET @SQL += '
				AND [CreatedDate] BETWEEN ''' + CONVERT(VARCHAR(10), @StartDate, 120) + ''' AND ''' + CONVERT(VARCHAR(10), @EndDate, 120) + '''
			'
		END
		SET @SQL += '
				AND [Type] = ''' + @Type + '''
		ORDER BY [Status] desc, [CreatedDate] desc 

		SET NOCOUNT OFF
		'
		EXEC(@SQL)
	END
END


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
